Subject: RE: Server "Mount" Questions

From: "Noveck, Dave" <[email-masked]>
Date: Mon, 16 Jul 2001 09:53:28 -0700

Som asks:
> BTW, how does client decide when to do PUTROOTFH or
> PUTPUBFH to start with?

I've never been able to figure out when a client would
use one or the other.  My server does the same thing
on receiving either one.  Are there any servers out
there that do different things for these two ops?

Also, what do clients currently do?  I suspect they do 
a mount by taking the path from mount and looking it 
up starting at the root filehandle.  Is there anybody 
who does anything else?

My feeling is that we should collapse these two ops into
one.

-----Original Message-----
From: Som [mailto:[email-masked]]
Sent: Monday, July 16, 2001 12:52 AM
To: Eric Kadison; [email-masked]
Subject: Re: Server "Mount" Questions

--- Eric Kadison <[email-masked]> wrote:
> Gents,
> 
> As a newbie to NFS V4, I have a few questions
> regarding a server's behavior
> in substitution for the old mount protocol.  These
> questions relate to
> LOOKUP and READDIR performance in sharing
> directories and in crossing mount
> points.  Permissions are not the issue -- assume
> they are all ok.  The
> scenario:
> 
> hosta (an NFS V4 Server) has a file system that
> includes:
> 
>      (root) 
>       /  \
>      /    \
>    fsa1   group
>     /      /  \
>    a1     /    \
>         fsa2   fsa3
> 
> hosta exports "fsa1", "fsa2" and "fsa3" with rw
> permission to all clients.
> 
> hostb (an NFS V4 Server and client) file system
> includes:
> 
>      (root) 
>       /  \
>      /    \
>    fsb4   mnt
>           /  \
>          /    \
>         b5    b6
> 
> The supervisor on hostb wants to find hosta's
> exported file systems, so
> brings up a file manager that issues to hosta:
> PUTROOTFH, READDIR.  
> 
> 1.  Will the READDIR result be: "fsa1", "fsa2",
> "fsa3"?  I expect it will be
> since hostb should not be able to see directory
> "group" on hosta as it is
> not exported.  So hosta presents a pseudo-file
> system showing just the
> exported directories.

After reading section 4.1.2 of Public File handle
definition, I thought client should do PUTPUBFH in
this case( instead of PUTROOTFH). Is that not correct?

BTW, how does client decide when to do PUTROOTFH or
PUTPUBFH to start with?

thanks, som.

=====
"Chess holds its master in its own bonds,
shackling the mind and brain so that the 
inner freedom of the very strongest must 
suffer"-Albert Einstein

__________________________________________________
Do You Yahoo!?
Get personalized email addresses from Yahoo! Mail
http://personal.mail.yahoo.com/

---

From: Som <[email-masked]>
Date: Mon, 16 Jul 2001 10:06:48 -0700 (PDT)

Yes, that should be the case. Reading at all the
discussion, everyone assumes that PUTROOTFH is the
operation which is the start point of your pseudo
filesystem.

Even this current discussion proceeded with that
assumption...
Now there must be objections to remove PUTPUBFH...so
let's hear those!

thanks, som.

---

From: Brent <[email-masked]>
Date: Mon, 16 Jul 2001 11:40:21 -0700

> My feeling is that we should collapse these two ops into

WebNFS clients do a non-root pathname evaluation
per RFC 2055.  Currently, the pathname in an NFS URL,

	nfs://server/path

is defined relative to a directory to which a public
filehandle is attached.  So, in Solaris you can
attach the public filehandle to some directory that's
not at the root, and provide some measure of location
independence on the server.

I think administrators should expect it to work the
same with NFSv4 as it does with v2 and v3.

If your server doesn't support separation of public
and root filehandles, then I think it's fine just
to co-locate them.

	Brent